#include <stdio.h>
#include <stdint.h>
#include <math.h>

#define SAMPLE_COUNT 100

int main(void) {
	FILE *outfile;
	uint64_t i;
	float samples[SAMPLE_COUNT * 2];
	float time;

	for(i = 0; i < SAMPLE_COUNT; i++) {
		time = (float) i / ((float) SAMPLE_COUNT);
		samples[i * 2] = cosf(6.28318530718 * time);
		samples[i * 2 + 1] = 0.0;

		printf("\rGenerating sample for time %f: %f\n", time, samples[i * 2]);
		fflush(stdout);
	}

	printf("\nWriting...\n");
	outfile = fopen("pure_sine.bin", "w");
	fwrite(samples, SAMPLE_COUNT * 2 * sizeof(float), 1, outfile);
	fclose(outfile);

	return 0;
}
