#pragma once

#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MIN(a, b) (a > b ? b : a)
#define MINIF(a, b, c) ((a > b && c) ? b : a)

struct CommonCBBuffer {
	void *base_addr;
	uint32_t read_counter;
	uint32_t write_counter;
	uint32_t total_len;
	int32_t readable_len;
};

struct CommonCBBuffer *common_circular_buffer_create(uint32_t len, bool is_infinite);
void common_circular_buffer_write(struct CommonCBBuffer *buffer, void *bytes, uint32_t byte_count);
uint32_t common_circular_buffer_read(struct CommonCBBuffer *buffer, void *bytes, uint32_t user_count);
void common_circular_buffer_free(struct CommonCBBuffer *buffer);

