#pragma once

#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#define COMMON_HASHTABLE_PRIME	17
#define COMMON_HASHTABLE_KEY_LENGTH	255

struct CommonHashtableTable {
	unsigned char size;
	struct CommonHashtableElement *base;
};

struct CommonHashtableElement {
	char *name;
	void *content;
};

unsigned char common_hashtable_compute_hash(const char *str, unsigned char modulus);
bool common_hashtable_initialize(struct CommonHashtableTable *hashtable, unsigned char hashtable_size);
void common_hashtable_free(struct CommonHashtableTable *hashtable);
struct CommonHashtableElement *common_hashtable_find(struct CommonHashtableTable *hashtable, const char *name);
bool common_hashtable_insert(struct CommonHashtableTable *hashtable, const char *name, void *content);

