#pragma once

#include <netdb.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <infiniband/verbs.h>

#include "common/hashtable.h"

struct CapuletRdmaMrMgr;

struct CapuletNetUdpQpInfoPacket {
	uint16_t lid;
	uint32_t qpn;
	uint32_t psn;
	uint8_t gid[16];
};

struct CapuletNetUdpMrQueryPacket {
	char name[16];
};

struct CapuletNetUdpMrInfoPacket {
	char name[16];
	void *addr;
	size_t size;
	uint32_t key;
};

struct CapuletNetUdpContext {
	struct CapuletNetUdpQpInfoPacket *local;
	struct CapuletNetUdpQpInfoPacket *remote;
};

struct CapuletNetUdpContext *capulet_net_udp_initialize();
int capulet_net_udp_serve_qp(struct CapuletNetUdpContext *ctx);
bool capulet_net_udp_serve_mr(struct CommonHashtableTable *hashtable, int server_socket);
int capulet_net_udp_send_qp(struct CapuletNetUdpContext *ctx, struct addrinfo *server_infos);
bool capulet_net_udp_query_mr(int server_socket, struct addrinfo *server_infos, char *name, struct CapuletNetUdpMrInfoPacket *mr_info_packet);
void capulet_net_udp_dump_qp_packet(struct CapuletNetUdpQpInfoPacket *packet);
void capulet_net_udp_free(struct CapuletNetUdpContext *ctx);

